## ncbi-vdb 3.2.1+dfsg

=== CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

cmake_minimum_required(VERSION 3.16)
if (WIN32)
	set (CMAKE_SYSTEM_VERSION 10.0 CACHE STRING INTERNAL FORCE)
endif()

# set( CMAKE_DISABLE_SOURCE_CHANGES ON ) # Cannot use with bison
# set( CMAKE_DISABLE_IN_SOURCE_BUILD ON )

option(LIBS_ONLY "Generate library targets only" ON)
option(TESTS_ONLY "Generate test targets only" OFF)

if( TESTS_ONLY AND LIBS_ONLY )
    message( "ERROR: TESTS_ONLY and LIBS_ONLY cannot be specified at the same time" )

elseif( TESTS_ONLY AND NOT LIBS_ONLY AND (${CMAKE_GENERATOR} MATCHES "Visual Studio.*" OR ${CMAKE_GENERATOR} STREQUAL "Xcode") )
    project(ncbi-vdb-tests)
    if( PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR )
        message(FATAL_ERROR "In-source builds are not allowed")
    endif()
    # calculate global settiungs, create output directories
    include( build/env.cmake NO_POLICY_SCOPE )

    message( "Generating tests only project..." )
    if(CMAKE_BUILD_TYPE STREQUAL "" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
        link_directories( ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG} )
        link_directories( ${CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG} )
    else()
        link_directories( ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE} )
        link_directories( ${CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE} )
    endif()
    add_subdirectory(test)

elseif( NOT TESTS_ONLY AND LIBS_ONLY AND (${CMAKE_GENERATOR} MATCHES "Visual Studio.*" OR ${CMAKE_GENERATOR} STREQUAL "Xcode") )
    project(ncbi-vdb)
    if( PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR )
        message(FATAL_ERROR "In-source builds are not allowed")
    endif()
    # calculate global settiungs, create output directories
    include( build/env.cmake NO_POLICY_SCOPE )

    message( "Generating libs only project..." )
    add_subdirectory(libs)
else()

    if( TESTS_ONLY )
        message( "ignoring TESTS_ONLY, use it only for MSVC or XCode" )
    endif()

    project(ncbi-vdb)
    if( PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR )
        message(FATAL_ERROR "In-source builds are not allowed")
    endif()
    # calculate global settiungs, create output directories
    include( build/env.cmake NO_POLICY_SCOPE )
    add_subdirectory(libs)
    if ( NOT LIBS_ONLY )
        add_subdirectory(test)
    endif()

endif()

#add_subdirectory(vdb3)

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell pwd)
include $(TOP)/build/Makefile.env

=== libs/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( CMAKE_POSITION_INDEPENDENT_CODE True )
add_compile_definitions( _LIBRARY )

add_subdirectory(ktst)
add_subdirectory(align)
add_subdirectory(axf) # sra tools dependency
add_subdirectory(blast)
add_subdirectory(cloud)
add_subdirectory(ext)
add_subdirectory(kapp)
add_subdirectory(kdb)
add_subdirectory(kdbtext)
add_subdirectory(kfc)
add_subdirectory(kfg)
add_subdirectory(kfs)
add_subdirectory(klib)
add_subdirectory(kns)
add_subdirectory(kproc)
add_subdirectory(krypto) # TODO: to be replaced with calls to mbedtls
add_subdirectory(schema)
add_subdirectory(sra)
add_subdirectory(sraxf) # same as axf
add_subdirectory(vdb)
add_subdirectory(vfs)
add_subdirectory(vxf)
add_subdirectory(wgsxf) # wgsxf and wwgsxf are the same
add_subdirectory(ncbi-vdb)

if ( SINGLE_CONFIG OR _NCBIVDB_CFG_PACKAGING )
    #
    # Install header files
    set( HEADERS align  cloud  insdc  kdb  kfg  klib  kproc   ktst  os sra   vfs
    cc     csra2  ext  kapp   kfc  kfs  kns   krypto  ncbi  vdb  )

    foreach( h IN ITEMS ${HEADERS} )
        install( DIRECTORY ${CMAKE_SOURCE_DIR}/interfaces/${h} DESTINATION ${INST_INCDIR} )
    endforeach()
endif()
if(_NCBIVDB_CFG_PACKAGING)
    install( FILES ${CMAKE_SOURCE_DIR}/LICENSE DESTINATION licenses)
endif()

#add_subdirectory(kxml) VDB-4797 moved to sra-tools
#add_subdirectory(loader) VDB-4855 moved to sra-tools/libs
#add_subdirectory(hdf5) VDB-4795
#add_subdirectory(tui) VDB-4803
#add_subdirectory(diagnose) VDB-4794 moved to sra-tools/test-sra
#add_subdirectory(ascp) VDB-4794 moved to sra-tools/libs/ascp

=== test/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

if(NOT CMAKE_TEST_OUTPUT_DIRECTORY)
    set(CMAKE_TEST_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/test-bin)
endif()
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_TEST_OUTPUT_DIRECTORY} )

if ( "GNU" STREQUAL "${CMAKE_C_COMPILER_ID}")
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable" )
endif()

add_subdirectory(kfc)

set( COMMON_LINK_LIBRARIES ktst kapp )
set( ADDITIONAL_LIBS "" )

# for the tests that link against libncbi-[w]vdb
if( WIN32 )
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ENTRY:wmainCRTStartup")
    set( COMMON_LIBS_READ  ${COMMON_LINK_LIBRARIES} ncbi-vdb Ws2_32 Crypt32 ${MBEDTLS_LIBS} )
    set( COMMON_LIBS_WRITE ${COMMON_LINK_LIBRARIES} ncbi-wvdb Ws2_32 Crypt32 ${MBEDTLS_LIBS} )
else()
    link_libraries( ${COMMON_LINK_LIBRARIES} )
    set( COMMON_LIBS_READ  ncbi-vdb  dl pthread ${MBEDTLS_LIBS} )
    set( COMMON_LIBS_WRITE ncbi-wvdb dl pthread ${MBEDTLS_LIBS} )
endif()


add_subdirectory(ktst)
add_subdirectory(cc)
add_subdirectory(ext)
add_subdirectory(judy_test)
add_subdirectory(klib)
add_subdirectory(kfs)
add_subdirectory(kfg)
add_subdirectory(kapp)
add_subdirectory(cloud)
add_subdirectory(krypto)
add_subdirectory(cipher)
add_subdirectory(kdb)
add_subdirectory(kdbtext)
add_subdirectory(kproc)
add_subdirectory(vdb)
add_subdirectory(sraxf)
add_subdirectory(vxf)
add_subdirectory(axf)
add_subdirectory(schema) # TODO: INT_TOOLS - see the schema CMakeLists.txt for the details
add_subdirectory(vfs)
add_subdirectory(ncbi-vdb)
# add_subdirectory(install)
add_subdirectory(align)
add_subdirectory(kns) # TODO: EXT_TOOLS - see the kns CMakeLists.txt for the details

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/align

include $(TOP)/build/Makefile.env

=== libs/axf/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( AXF_SRC
    ref-tbl-sub-select
    ref-restore-read
    align-restore-read
    raw-restore-read
    raw-restore-qual
    seq-restore-read
    seq-restore-linkage-group
    seq-construct-read
    cigar
    project_read_from_sequence
    not-my-row
    template-len
    get-sam-flags
    align-ref-pos
    align-ref-name
    align-ref-seq-id
    align-local_ref_id
    align-local_ref_start
    generate-mismatch-qual
    mismatch-restore-qual
    ref-preserve_qual
    ref-tbl
    make-cmp-read_desc
    get_mate_align_ids
    range-list
    refseq
    wgs
    restore-read
)

set( WAXF_SRC
    ${AXF_SRC}
    refseq-stats
)

GenerateStaticLibs( axf "${AXF_SRC}" )
GenerateStaticLibs( waxf "${WAXF_SRC}" )

add_compile_definitions( __mod__="libs/axf" )

=== libs/cloud/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/cloud

include $(TOP)/build/Makefile.env

=== libs/kdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( KDB_SRC
    btree
#    rowset
#    rowset-simple

    kdb-cmn
    rkdb
    wkdb

    dbmgr-cmn
    manager-base
    database-base
    table-base
    column-base
    columnblob-base.cpp
    meta-base
    metanode-base
    index-base

    ptrieval-v1
    ptrieval-v2

    idstats

    database-cc
    table-cc
    column-cc
    dbcc-cmn

    trieval-v1
    trieval-v2

    index-cmn

    rindex
    ridxblk
    rtrieidx-v1
    rtrieidx-v2
    ru64idx-v3

    windex
    widxblk
    wtrieidx-v1
    wtrieidx-v2
    wu64idx-v3

    rcolumn
#    rcolumnblob
    RColumnBlob.cpp

    wcolumn
#    wcolumnblob
    WColumnBlob.cpp

    rmeta
    rmetadatanode

    wmeta
    wmetadatanode

    coldata
    rcoldata
    rcolidx
    rcolidx0
    rcolidx1
    rcolidx2

    wcoldata
    wcolidx
    wcolidx0
    wcolidx1
    wcolidx2

    rdbmgr
    rtable
    rdatabase

    wdbmgr
    wdatabase
    wtable

    page-map
)

GenerateStaticLibs( kdb "${KDB_SRC}" )

add_compile_definitions (__mod__="libs/kdb")

=== libs/kdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/kdb

include $(TOP)/build/Makefile.env

=== libs/kdbtext/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( KDBTEXT_SRC
    api-manager.cpp
    manager.cpp
    database.cpp
    table.cpp
    column.cpp
    index.cpp
    path.cpp
    metadata.cpp
    columnblob.cpp
    metanode.cpp
)

GenerateStaticLibs( kdbtext "${KDBTEXT_SRC}" )

add_compile_definitions (__mod__="libs/kdbtext")

=== libs/kdbtext/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = libs/kdbtext

include $(TOP)/build/Makefile.env

=== libs/kfc/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set ( UNIX_SRC unix/sysctx.c unix/sysrsrc.c )
set ( BSD_SRC ${UNIX_SRC} )
set ( LINUX_SRC ${UNIX_SRC} )
set ( MAC_SRC ${UNIX_SRC} )
set ( WIN_SRC win/sysctx.c win/sysrsrc.c )

if( "bsd" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "linux" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "mac" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${MAC_SRC} )
elseif ( "windows" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${WIN_SRC} )
endif()

set( SRC
    except
    refcount
    rsrc
    tstate
    vtbl
    xc
    ${OS_SPECIFIC_SRC}
)

GenerateStaticLibs( kfc "${SRC}" )

add_compile_definitions (__mod__="libs/kfc")
include_directories( BEFORE ${CMAKE_CURRENT_SOURCE_DIR} )

=== debian/changelog ===
ncbi-vdb (3.2.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 09 Apr 2025 21:28:39 -0400

ncbi-vdb (3.2.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Move python3 to main Build-Depends (from -Arch) and add dh-python.
    - Have ncbi-vdb-data replace sra-toolkit << 3.2 over debian.kfg and
      (for now) incorporate a virtual python3-vdb package, to be split out
      into a regular package post-Trixie.
    - Belatedly have -dev packages depend on ${devlibs:Depends} (from
      d-shlibs) rather than the inapplicable ${shlibs:Depends}.
  * debian/copyright: Substitute a URL for the FSF's postal address.
    (See #1080497.)
  * debian/debian.kfg: New; taken over from sra-toolkit, augmented with a
    central /vdb/schema/paths = "/usr/lib/ncbi-vdb" setting.
  * debian/ncbi-vdb-data.install: Install debian.kfg to /etc/ncbi and
    py_vdb/vdb.py to /usr/lib/python3/dist-packages.
  * debian/patches/fix_{cmake,x32}.patch: Formally update accordingly.
  * debian/patches/python-use-default-runtime.patch (new): Bypass upstream's
    logic for locating VDB shared libraries in favor of tacking on .3 and
    honoring the system search path.
  * debian/rules:
    - Stop injecting /usr/lib/ncbi-vdb/ into schema include directives.
    - Enable DebHelper's Python 3 addon.
  * debian/.gitignore: Ignore generated maintainer script fragments.
  * .gitignore: Ignore Debian additions.
  * Standards-Version: 4.7.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 08 Apr 2025 21:43:30 -0400

ncbi-vdb (3.1.1+dfsg-1) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/copyright: update according to lrc

 -- Andreas Tille <tille@debian.org>  Thu, 12 Dec 2024 09:55:38 +0100

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs (>= 0.104),
               dh-python,
               python3
Build-Depends-Arch: cmake,
                    libbz2-dev,
                    libxml2-dev,
                    libmagic-dev,
                    libmbedtls-dev (>= 3),
                    zlib1g-dev,
                    libzstd-dev,
                    flex,
                    bison,
                    doxygen,
                    graphviz,
                    chrpath
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-vdb
Vcs-Git: https://salsa.debian.org/med-team/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb
Rules-Requires-Root: no

Package: libncbi-vdb3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ncbi-vdb-data (>= ${source:Version})
Breaks: sra-toolkit (<< 2.11~)
Description: libraries for using data in the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for reading VDB data.

Package: libncbi-vdb-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${devlibs:Depends},
         ${misc:Depends},
         libncbi-vdb3 (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         libzstd-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This is the development package for reading VDB data.

Package: ncbi-vdb-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Recommends: ${python3:Depends}
Provides: python3-vdb
Breaks: libncbi-vdb2 (<< 2.11.2+dfsg-5~)
Replaces: libncbi-vdb2 (<< 2.11.2+dfsg-5~), sra-toolkit (<< 3.2)
Description: schemata and defaults for the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains VDB schemata for SRA data and default
 configuration files for VDB libraries.  For the time being, it also
 contains a Python wrapper for VDB.

Package: libncbi-wvdb3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ncbi-vdb-data (>= ${source:Version})
Description: virtual layer update module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for updating VDB data.

Package: libncbi-wvdb-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${devlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb3 (= ${binary:Version})
Description: virtual layer update module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains development files for updating VDB data.

Package: libsam-extract3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SAM extraction module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides an interface
 for extracting Sequence/Alignment Map (SAM) files.

Package: libsam-extract-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${devlibs:Depends},
         ${misc:Depends},
         libsam-extract3 (= ${binary:Version})
Description: SAM extraction module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides development
 files for extracting Sequence/Alignment Map (SAM) files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DH_BUILD_MAINT_OPTIONS := nocheck

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(DEB_SOURCE)/$(OS)/gcc
# VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
VDB_ARCH := *
LIBINSTALLDIR := debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
SCHEMADIR := debian/ncbi-vdb-data/usr/lib/$(DEB_SOURCE)
DSLMFLAGS := --commit --multiarch --devunversioned --exclude-la

# See debian/patches/fix-linking
# export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEB_SOURCE)/$(MULTIARCH)
	rm -rf obj-*
	rm -rf libs/cipher/cipher-1.7/cipher/__pycache__
	rm -rf test/schema/actual
	rm -rf test/vdb/db/SparseCol*
	rm -rf test/vdb/db/VCursorCommit_BufferOverflow
	rm -f libs/ngs-jni/jni.h
	rm -f libs/ngs-jni/jni_md.h
	rm -f build/ld.linux.exe_cmd.sh
	rm -f debian/common-install-stamp
	rm -f interfaces/cc/gcc/aarch64
	rm -f test/cloud/cloud-kfg/.aws/c*
	rm -f test/kdb/root/sra/SRR600096.sra.cache
	rm -f test/kdb/user-settings.mkfg
	rm -f test/vdb/kfg/*/user-settings.mkfg
	rm -f test/vfs/caching-kfg/unix/user-settings.mkfg
	rm -f test/vfs/tmp.perm-file.tmp
	rm -f test/vfs/user-settings.mkfg
	rm -f test/vxf/local_config/user-settings.mkfg

override_dh_auto_configure-indep:;

override_dh_auto_build-arch:
	ln -s arm64 interfaces/cc/gcc/aarch64
	dh_auto_build --no-parallel -- NO_VDB3=1
	# we need to make really sure that no 'vdb_'-prefixed functions will remain ...
	if find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep -q vdb_mbedtls ; then \
	    find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep vdb_mbedtls ; \
	    grep -Rl vdb_mbedtls  debian/tmp/* ; \
	    exit 1 ; \
	    false ; \
	fi

override_dh_auto_build-indep:;

override_dh_auto_test-arch:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test -- NO_VDB3=1 || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_auto_test-indep:;

override_dh_prep:
	dh_prep -Xdebian/tmp

debian/common-install-stamp:
	mkdir -p debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	cp -a interfaces/* debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done
	# Move around kfg files to the place where it used to be in version 2.x
	mv debian/libncbi-vdb-dev/usr/include/ncbi-vdb/kfg/ncbi $(SCHEMADIR)/kfg
	touch $@

override_dh_auto_install-arch: debian/common-install-stamp
	dh_auto_install -- NO_VDB3=1
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
#		    --movedev $(LIBINSTALLDIR)/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
#		    --movedev $(LIBINSTALLDIR)/libkff.a		usr/lib/$(MULTIARCH) \
#		    --movedev $(LIBINSTALLDIR)/libkxfs.a	usr/lib/$(MULTIARCH) \
#		    --movedev $(LIBINSTALLDIR)/libkxml.a	usr/lib/$(MULTIARCH) \
#                    --movedev $(LIBINSTALLDIR)/libload.a	usr/lib/$(MULTIARCH) \
#		    --movedev $(LIBINSTALLDIR)/libtui.a		usr/lib/$(MULTIARCH) \
#                    --movedev $(LIBINSTALLDIR)/libtui_cpp.a	usr/lib/$(MULTIARCH) \

	d-shlibmove $(DSLMFLAGS) \
		    --movedev $(LIBINSTALLDIR)/libkapp.a	usr/lib/$(MULTIARCH) \
		    --movedev $(LIBINSTALLDIR)/libktst.a	usr/lib/$(MULTIARCH) \
                    --movedev obj-*/ilib/libkapp-norsrc.a	usr/lib/$(MULTIARCH) \
		    $(LIBINSTALLDIR)/libncbi-vdb.so
	# json-response.h and services-priv.h are needed by sra-sdk, but
	# the latter shouldn't replace interfaces/vfs/services-priv.h.
	dh_install -plibncbi-vdb-dev libs/vfs/json-response.h usr/include/ncbi-vdb/vfs
	cp libs/vfs/services-priv.h debian/libncbi-vdb-dev/usr/include/ncbi-vdb/vfs/services-priv-internal.h
	d-shlibmove $(DSLMFLAGS) \
		    $(LIBINSTALLDIR)/libncbi-wvdb.so
	d-shlibmove $(DSLMFLAGS) \
		    $(LIBINSTALLDIR)/libsam-extract.so
	find debian/lib* -name .gitignore -delete

override_dh_auto_install-indep: debian/common-install-stamp
